﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
  Type MicIdxType(idx, inc As Int) ' index (0-6, -99 off), increment
  
  Public ResCode As Int ' result code 1-success, 0-nothing, -1-error
  Public ResList As List ' on success list of recog results
  
  Private pnParent As Panel
  Private cbComponent As Object
  Private cbSubName As String
  
  Private JO As JavaObject
  Private RdyForSpch As Boolean = False
  Private Initialized As Boolean = False
  
  Private pnSR As Panel
  Private ivMic As ImageView
  Private bnSS As Button
  
  Private SpchRecog As JavaObject
  Private tmMic, tmLstn As Timer
  Private bmOff, bmMic(7) As Bitmap
  Private MicIdx As MicIdxType
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(prnt As Panel, cmp As Object, cb As String) As Boolean
  pnParent = prnt
  cbComponent = cmp
  cbSubName = cb
  
  prnt.LoadLayout("sr1")
  
  prnt.Color = Colors.ARGB(80, 0, 0, 0)
  
  pnSR.Left = (prnt.Width - pnSR.Width) / 2
  pnSR.Top = (prnt.Height - pnSR.Height) / 2
  
  SpchRecog.InitializeStatic("android.speech.SpeechRecognizer")
  JO = SpchRecog.RunMethod("createSpeechRecognizer", Array(JO.InitializeContext))
  
  If Not(IsRecognitionAvailable) Then
    Log("Speech Recognition Not Available")
    Return(False)
  End If
  
  Dim Event As Object = JO.CreateEvent("android.speech.RecognitionListener", "Received", "")
  JO.RunMethod("setRecognitionListener", Array(Event))
  Initialized = True
  
  ResList.Initialize
  ResCode = 0
  
  bmOff.Initialize(File.DirAssets, "micoff.png")
  
  bmMic(0).Initialize(File.DirAssets, "mic0.png")
  bmMic(1).Initialize(File.DirAssets, "mic1.png")
  bmMic(2).Initialize(File.DirAssets, "mic2.png")
  bmMic(3).Initialize(File.DirAssets, "mic3.png")
  bmMic(4).Initialize(File.DirAssets, "mic4.png")
  bmMic(5).Initialize(File.DirAssets, "mic5.png")
  bmMic(6).Initialize(File.DirAssets, "mic6.png")
  
  bnSS.Text = "Begin Listening"

  MicIdx.idx = -99
  MicIdx.inc = 1
  
  tmMic.Initialize("tmMic", 250)
  tmMic.Enabled = True
  
  tmLstn.Initialize("tmLstn", 250)

  Return(True)
End Sub

Public Sub Show(px As Float, py As Float, alstn As Boolean) ' posn from left/top, auto listen
  ResCode = 0
  
  pnParent.Enabled = True
  pnParent.Visible = True
  pnParent.BringToFront
  
  pnSR.Left = (pnParent.Width - pnSR.Width) * px
  pnSR.Top = (pnParent.Height - pnSR.Height) * py
  
  If (alstn) Then tmLstn.enabled = True
End Sub

Public Sub Hide
  pnParent.Enabled = False
  pnParent.Visible = False
  pnParent.SendToBack  
End Sub

Public Sub IsInitialized As Boolean
  Return Initialized
End Sub

Public Sub IsRecognitionAvailable As Boolean
  Dim JO1 As JavaObject
  JO1.InitializeContext
  
  Return JO.RunMethod("isRecognitionAvailable", Array(JO1))
End Sub

Public Sub StartListening
  Private RecognizerIntent As Intent

  RecognizerIntent.Initialize("android.speech.action.RECOGNIZE_SPEECH", "")
  RecognizerIntent.PutExtra("android.speech.extra.LANGUAGE_PREFERENCE", "en")
  RecognizerIntent.PutExtra("calling_package", Application.PackageName)
  RecognizerIntent.PutExtra("android.speech.extra.LANGUAGE_MODEL", "web_search")
'  RecognizerIntent.PutExtra("android.speech.extras.SPEECH_INPUT_POSSIBLY_COMPLETE_SILENCE_LENGTH_MILLIS", 10000)
  RecognizerIntent.PutExtra("android.speech.extra.MAX_RESULTS", 1)
  
  Log("New Intent")
  
  RdyForSpch = False

  JO.RunMethod("startListening", Array(RecognizerIntent))
  
  MicIdx.idx = Floor(bmMic.Length / 2) - 1 ' start mic in middle, pre dec
  MicIdx.inc = 1 ' incrementing
  tmMic.Enabled = True
End Sub

Public Sub StopListening
  JO.RunMethod("stopListening", Null)
End Sub

Sub ListenDone
  bnSS.Text = "Recognizing"
  
  If (tmMic.Enabled) Then MicIdx.idx = -99 ' show mic off
End Sub

Sub RecogDone
  bnSS.Text = "Begin Listening"
  
  If (tmMic.Enabled) Then MicIdx.idx = -99 ' show mic off
End Sub

Sub bnSS_Click
  If (bnSS.Text.StartsWith("Begin")) Then
    bnSS.Text = "Stop Listening"
	
    StartListening
  Else If (bnSS.Text.StartsWith("Stop")) Then
    bnSS.Text = "Begin Listening"
	
    StopListening
  End If
End Sub

Sub tmMic_Tick
  If (MicIdx.idx = -99) Then
    ivMic.Bitmap = bmOff
    tmMic.Enabled = False
  Else
    Dim i As Int = MicIdx.idx
	
	If (i >= bmMic.Length - 1) Then MicIdx.inc = -1 ' reverse direction
	
	If (i <= 0) Then MicIdx.inc = 1 ' reverse direction
	
	MicIdx.idx = i + MicIdx.inc
	
	Select(MicIdx.idx)
	  Case 0
	    ivMic.Bitmap = bmMic(0)
		
	  Case 1
	    ivMic.Bitmap = bmMic(1)
		
	  Case 2
	    ivMic.Bitmap = bmMic(2)
		
	  Case 3
	    ivMic.Bitmap = bmMic(3)
		
	  Case 4
	    ivMic.Bitmap = bmMic(4)
		
	  Case 5
	    ivMic.Bitmap = bmMic(5)
		
	  Case 6
	    ivMic.Bitmap = bmMic(6)
		
	End Select
  End If
End Sub

Sub tmLstn_Tick
  tmLstn.Enabled = False
  
  If (bnSS.Text.StartsWith("Begin")) Then bnSS_Click
End Sub

Public Sub Destroy
  tmMic.Enabled = False
  tmLstn.Enabled = False
  
  JO.RunMethod("destroy", Null)
End Sub

Private Sub Received_Event(MethodName As String, Args() As Object) As Object
  Select MethodName
    Case "onReadyForSpeech"
      RdyForSpch = True
      Log("Ready for speech")
	  
    Case "onBeginningOfSpeech"
      Log("Begin speech")
	  
    Case "onEndOfSpeech"
      Log("End of speech")
	  
	  ListenDone
	  
    Case "onError"
	  If (RdyForSpch) Then
        Dim ErrorMsg As String = GetErrorText(Args(0))
		
        Log("Failed " & ErrorMsg)
		
'        If (Args(0) <> SpchRecog.GetField("ERROR_CLIENT")) Then

		RecogDone
		
		ResCode = -1
        ResList.Clear
        ResList.Add(ErrorMsg)
		
		If (SubExists(cbComponent, cbSubName)) Then CallSubDelayed(cbComponent, cbSubName)
      End If
	  
    Case "onResults"
      Dim Results As JavaObject = Args(0)
      Dim Matches As List = Results.RunMethod("getStringArrayList", Array("results_recognition"))
	  
      Log(Matches.Size)
	  
	  RecogDone
	  
	  ResList.Clear
	  
	  For Each s1 As String In Matches
        ResList.Add(s1)
      Next
	  
	  If (ResList.Size > 0) Then ResCode = 1 Else ResCode = 0
      If (SubExists(cbComponent, cbSubName)) Then CallSubDelayed(cbComponent, cbSubName)
	  
    Case "onRmsChanged"
	  
  End Select
End Sub

Sub GetErrorText(ErrorCode As Int) As String
  Select ErrorCode
    Case SpchRecog.GetField("ERROR_AUDIO")
      Return "Audio Recording error"
	  
     Case SpchRecog.GetField("ERROR_CLIENT")
       Return "Client side error"
	   
     Case SpchRecog.GetField("ERROR_INSUFFICIENT_PERMISSIONS")
      Return "Insufficient permissions"
	  
     Case SpchRecog.GetField("ERROR_NETWORK")
       Return "Network error"
	   
     Case SpchRecog.GetField("ERROR_NETWORK_TIMEOUT")
       Return "Network timeout"
	   
      Case SpchRecog.GetField("ERROR_NO_MATCH")
       Return "No match"
	   
      Case SpchRecog.GetField("ERROR_RECOGNIZER_BUSY")
       Return "RecognitionService busy"
	   
      Case SpchRecog.GetField("ERROR_SERVER")
       Return "error from server"
	   
     Case SpchRecog.GetField("ERROR_SPEECH_TIMEOUT")
      Return "No speech input"
	  
     Case Else
       Return "Didn't understand, please try again."
	   
  End Select
End Sub
